#!/usr/bin/env python
# -*- coding: utf-8 -*-

#------------------------------------------------------------
# A LIRE : COMMENT TOUT A ETE CREE
#------------------------------------------------------------
#
#Import Modules

import os, sys, time, random, copy, pprint
import termios, tty, fcntl, thread, curses, locale

QUESTION_MAXIMIZE_SHELL = "Maximiser la taille à la taille du shell (o/n/q) ?"
ANSWER_YES  = 'o'
ANSWER_NO   = 'n'
ANSWER_QUIT = 'q'

DEFAULT_DATA_FILE = 'datas/boxworld!.txt'
QUESTION_ENTER_FILE_DATA = "Entrez un fichier de données à charger (par défaut : %s) :"

def curses_main(stdscr, code):
    curses.savetty()
    try:
        curses.curs_set(0)
        # 0 : curses.COLOR_BLACK,
        # 1 : curses.COLOR_RED,
        # 2 : curses.COLOR_GREEN,
        # 3 : curses.COLOR_YELLOW,
        # 4 : curses.COLOR_BLUE,
        # 5 : curses.COLOR_MAGENTA,
        # 6 : curses.COLOR_CYAN,
        # 7 : curses.COLOR_WHITE
        #curses.init_pair(1, curses.COLOR_RED, curses.COLOR_WHITE)
        #stdscr.addstr( "- -", curses.color_pair(1) )
        #stdscr.addstr( "Couleurs : "+str(curses.COLORS)+" / " )
        #stdscr.addstr( "Paires possibles : "+str(curses.COLOR_PAIRS)+" " )
        #stdscr.addstr(0, 0, "Current mode: Typing mode", curses.A_UNDERLINE)
        stdscr.addstr(1, 0, " o", curses.A_UNDERLINE)
        stdscr.addstr(1, 2, " o")

        (xmin,ymin) = stdscr.getbegyx()
        (xmax,ymax) = stdscr.getmaxyx()
        stdscr.addstr(2, 0, "Coordonnées : (%d,%d) / (%d,%d)" % (xmin, ymin, xmax, ymax))

        # You have to use fonts that can display this :
        # you should see :
        # - a small circle               : 9675 : <○>
        # - a dot in a white square      : 9688 : <◘>
        # - a circle in a white square   : 9689 : <◙>
        # - a black & white head smiling : 9786 : <☺>
        # - a white & black head smiling : 9787 : <☻>

        # - elements for drawing the maze :
        # - 9472 : <─>
        # - 9474 : <│>
        # - 9552 : <═>
        # - 9553 : <║>

        # - 9484 : <┌>
        # - 9496 : <┘>
        # - 9488 : <┐>
        # - 9492 : <└>
        # - 9500 : <├>
        # - 9508 : <┤>
        # - 9516 : <┬>
        # - 9524 : <┴>
        # - 9532 : <┼>

        # - 9556 : <╔>
        # - 9565 : <╝>
        # - 9559 : <╗>
        # - 9562 : <╚>
        # - 9568 : <╠>
        # - 9571 : <╣>
        # - 9574 : <╦>
        # - 9577 : <╩>
        # - 9580 : <╬>

        j = 0
        #stdscr.addstr(j, 0, "Basic Latin")
        #for i in range(0x0011, 0x007F):
        #    stdscr.addstr(unichr(i).encode('utf-8'))
        #j = j + 9
        #stdscr.addstr(j, 0, "Latin-1 Supplement")
        #for i in range(0x0080, 0x00FF):
        #    stdscr.addstr(unichr(i).encode('utf-8'))
        #j = j + 9
        stdscr.addstr(j, 0, "Latin Extended-A")
        for i in range(0x0100, 0x017F):
            stdscr.addstr(unichr(i).encode('utf-8'))
        j = j + 9
        stdscr.addstr(j, 0, "Latin Extended-B")
        for i in range(0x0180, 0x024F):
            stdscr.addstr(unichr(i).encode('utf-8'))
        j = j + 9
        stdscr.addstr(j, 0, "Box Drawing")
        for i in range(0x2500, 0x257F):
            stdscr.addstr('<'+str(i)+':'+unichr(i).encode('utf-8')+'>')
        j = j + 9
        stdscr.addstr(j, 0, "Block Elements")
        for i in range(0x2580, 0x259F):
            stdscr.addstr('<'+str(i)+':'+unichr(i).encode('utf-8')+'>')
        j = j + 9
        stdscr.addstr(j, 0, "Geometric Shapes")
        for i in range(0x25A0, 0x25FF):
            stdscr.addstr('<'+str(i)+':'+unichr(i).encode('utf-8')+'>')
        j = j + 9
        stdscr.addstr(j, 0, "Miscellaneous Symbols")
        for i in range(0x2600, 0x26FF):
            stdscr.addstr('<'+str(i)+':'+unichr(i).encode('utf-8')+'>')
        #j = j + 9
        #stdscr.addstr(j, 0, "Dingbats")
        #for i in range(0x2700, 0x27BF):
        #    stdscr.addstr(unichr(i).encode('utf-8'))
        #j = j + 9
        #stdscr.addstr(j, 0, "Miscellaneous Mathematical Symbols-A")
        #for i in range(0x27C0, 0x27EF):
        #    stdscr.addstr(unichr(i).encode('utf-8'))
        #j = j + 9
        #stdscr.addstr(j, 0, "Supplemental Arrows-A")
        #for i in range(0x27F0, 0x27FF):
        #    stdscr.addstr(unichr(i).encode('utf-8'))
        #j = j + 9
        #stdscr.addstr(j, 0, "Miscellaneous Symbols and Arrows")
        #for i in range(0x2B00, 0x2BFF):
        #    stdscr.addstr(unichr(i).encode('utf-8'))

        stdscr.refresh()

        # halfdelay() = "rendre getch() non bloquant",
        # halfdelay(1) = délai d'attente = 1/10 ème de s. :
        curses.halfdelay(1)
        while True:
            try:
                c=stdscr.getch()
            except:
                c=-1
            if c<0:
                pass
            elif 0<c<256:
                if chr(c) in 'Qq':
                    break
                stdscr.addstr(0,50, curses.keyname(c)+ ' pressed')
                stdscr.refresh()
            elif c==curses.KEY_UP:
                pass
            elif c==curses.KEY_DOWN:
                pass
            elif c==curses.KEY_LEFT:
                pass
            elif c==curses.KEY_RIGHT:
                pass
            elif c==curses.KEY_HOME:
                pass
            elif c==curses.KEY_END:
                pass
            else:
                pass
    finally:
        curses.resetty()

def main():
    locale.setlocale(locale.LC_ALL, '')
    code = locale.getpreferredencoding()

    #print QUESTION_MAXIMIZE_SHELL
    #maximize = str.lower(raw_input('>'))
    #if maximize==ANSWER_QUIT:
    #    exit(0)
    #maximize = (maximize == 'o')

    #print QUESTION_ENTER_FILE_DATA % (DEFAULT_DATA_FILE)
    #filename = raw_input('>')
    #(width, height) = getTerminalSize()
    #print width, height

    curses.wrapper(curses_main, code)

    ##thread.start_new_thread(keypress, ())
    ##while True:
    ##    if char is not None:
    ##        print "Key pressed is " + char
    ##        break
    ##    print "Program is running"
    ##    time.sleep(1)

# Lorsque le script est exécuté, appeler la fonction principale :
if __name__ == '__main__':
    main()

